# encoding: UTF-8
=begin
TIG (c) 2021
All rights reserved. 
Makes a text list of the materials in a model, by 'name'.
Run from menu item : Extensions > Materials-name-list
=end
module TIG
  module Materials_name_list
    #menu
    unless @loaded
			UI.menu("Plugins").add_item( "Materials-name-list" ){ self.run() }
      @loaded=true
		end
    ###
    def self.run()
      model=Sketchup.active_model
      mats=model.materials
      names=[]
      mats.each{|mat| names << mat.display_name }
      names.sort!
      ###
      ### NB: it's harder, but not impossible, to reduce the list by omitting loaded but unused materials...
      ###
      # 1. into Ruby Console
      SKETCHUP_CONSOLE.show
      puts
      puts names
      puts
      # 2. into a file
      mname=model.title
      if ! mname || mname==""
        mname="Untitled" #model never saved
      end
      path=model.path
      if ! path || path==""
        path=Dir.pwd
      else
        path=File.dirname(path)
      end
      ofile=File.join(path, mname+"_mats.csv")
      begin
        file=File.new(ofile, "w")
      rescue### trap if open
        UI.messagebox("File:\n\n  "+ofile+"\n\nCannot be written - it's probably already open.\nClose it and try making it again...\n\nExiting...")
        return nil
      end
      file.puts(names)
      file.close
      ###
      ### open csv file
      if Sketchup.version.to_i >= 14 && Sketchup.platform == :platform_osx
        `open "#{ofile}"`
      else # it is WIN or old MAC
        UI.openURL("file:///#{ofile}")
      end
      ###
    end
  end
end